(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-click-outside')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue-click-outside'], factory) :
    (global = global || self, factory(global.LbVueFloatMenu = {}, global.ClickOutside));
}(this, (function (exports, ClickOutside) { 'use strict';

    ClickOutside = ClickOutside && Object.prototype.hasOwnProperty.call(ClickOutside, 'default') ? ClickOutside['default'] : ClickOutside;

    //

    var script = {
        name: 'lb-vue-floatmenu',
        directives: {
            'click-outside': ClickOutside,
        },
        data: function data()
        {
            return {
                top: 'auto',
                bottom: 'auto',
                left: 0,
                display: 'none',
                item: null,
                submenuPosition: '249px',
            };
        },
        props: [],
        mounted: function mounted()
        {
            var me = this;

            window.addEventListener('scroll', me.close);
        },
        watch:
        {

        },
        methods:
        {
            open: function open(e, item)
            {
                var me = this;
                e.preventDefault();
                e.stopPropagation();

                me.display = '';

                me.item = item;

                if (e.clientY > window.innerHeight / 2)
                {
                    me.bottom = (window.innerHeight - e.clientY - 5) + "px";
                    me.top = 'auto';
                }
                else
                {
                    me.top = (e.clientY - 5) + "px";
                    me.bottom = 'auto';
                }

                if (e.clientX + 300 > window.innerWidth)
                {
                    me.left = (e.clientX - 5 - 240) + "px";
                    me.submenuPosition = '-249px';
                }
                else
                {
                    me.left = (e.clientX - 5) + "px";
                    me.submenuPosition = '249px';
                }
            },
            close: function close()
            {
                var me = this;

                me.display = 'none';
            },
            evtclose: function evtclose(evt)
            {
                var me = this;

                if (evt.relatedTarget == null)
                {
                    return;
                }

                me.close();
            },
        },
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
    /* server only */
    , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
      if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
      } // Vue.extend constructor export interop.


      var options = typeof script === 'function' ? script.options : script; // render functions

      if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true; // functional template

        if (isFunctionalTemplate) {
          options.functional = true;
        }
      } // scopedId


      if (scopeId) {
        options._scopeId = scopeId;
      }

      var hook;

      if (moduleIdentifier) {
        // server build
        hook = function hook(context) {
          // 2.3 injection
          context = context || // cached call
          this.$vnode && this.$vnode.ssrContext || // stateful
          this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
          // 2.2 with runInNewContext: true

          if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
            context = __VUE_SSR_CONTEXT__;
          } // inject component styles


          if (style) {
            style.call(this, createInjectorSSR(context));
          } // register component module identifier for async chunk inference


          if (context && context._registeredComponents) {
            context._registeredComponents.add(moduleIdentifier);
          }
        }; // used by ssr in case component is cached and beforeCreate
        // never gets called


        options._ssrRegister = hook;
      } else if (style) {
        hook = shadowMode ? function () {
          style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
        } : function (context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook) {
        if (options.functional) {
          // register for functional component in vue file
          var originalRender = options.render;

          options.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context);
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = options.beforeCreate;
          options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }

      return script;
    }

    var normalizeComponent_1 = normalizeComponent;

    var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
    function createInjector(context) {
      return function (id, style) {
        return addStyle(id, style);
      };
    }
    var HEAD = document.head || document.getElementsByTagName('head')[0];
    var styles = {};

    function addStyle(id, css) {
      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = {
        ids: new Set(),
        styles: []
      });

      if (!style.ids.has(id)) {
        style.ids.add(id);
        var code = css.source;

        if (css.map) {
          // https://developer.chrome.com/devtools/docs/javascript-debugging
          // this makes source maps inside style tags work properly in Chrome
          code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

          code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
        }

        if (!style.element) {
          style.element = document.createElement('style');
          style.element.type = 'text/css';
          if (css.media) { style.element.setAttribute('media', css.media); }
          HEAD.appendChild(style.element);
        }

        if ('styleSheet' in style.element) {
          style.styles.push(code);
          style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
        } else {
          var index = style.ids.size - 1;
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) { style.element.removeChild(nodes[index]); }
          if (nodes.length) { style.element.insertBefore(textNode, nodes[index]); }else { style.element.appendChild(textNode); }
        }
      }
    }

    var browser = createInjector;

    /* script */
    var __vue_script__ = script;

    /* template */
    var __vue_render__ = function() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c(
        "div",
        {
          ref: "lb_float_menu",
          staticClass: "right-click-menu",
          style:
            "top: " +
            _vm.top +
            "; bottom: " +
            _vm.bottom +
            "; left: " +
            _vm.left +
            "; display: " +
            _vm.display +
            "; --submenu-position: " +
            _vm.submenuPosition +
            ";",
          on: { mouseleave: _vm.evtclose }
        },
        [_c("div", [_vm._t("default", null, { item: _vm.item })], 2)]
      )
    };
    var __vue_staticRenderFns__ = [];
    __vue_render__._withStripped = true;

      /* style */
      var __vue_inject_styles__ = function (inject) {
        if (!inject) { return }
        inject("data-v-1a52a51d_0", { source: "\n.right-click-menu[data-v-1a52a51d] {\n    background: #FAFAFA;\n    border: 1px solid #BDBDBD;\n    box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 5px 0 rgba(0,0,0,.12);\n    display: block;\n    position: fixed;\n    min-width: 250px;\n    z-index: 999999;\n}\n.right-click-menu ul[data-v-1a52a51d] {\n    list-style: none;\n    margin: 0;\n    padding: 0;\n    z-index: 500;\n}\n.right-click-menu ul li[data-v-1a52a51d] {\n    border-bottom: 1px solid #E0E0E0;\n    margin: 0;\n    padding: 5px 5px;\n    position: relative;\n    cursor: pointer;\n}\n.right-click-menu div > ul > li[data-v-1a52a51d]::before {\n    position:absolute;\n    content:\"\";\n    left: -15px;\n    right: -15px;\n}\n.right-click-menu div > ul > li[data-v-1a52a51d]:first-child::before {\n    bottom: 0px;\n    top: -30px;\n}\n.right-click-menu div > ul > li[data-v-1a52a51d]:last-child::before{\n    top: 0px;\n    bottom: -30px;\n}\n.right-click-menu div > ul > li[data-v-1a52a51d]:not(:first-child):not(:last-child)::before {\n    top: 0px;\n    bottom: 0px;\n}\n.right-click-menu ul li svg[data-v-1a52a51d] {\n    position: absolute;\n    right: 5px;\n    top: 5px;\n}\n.right-click-menu ul li[data-v-1a52a51d]:last-child {\n    border-bottom: none;\n}\n.right-click-menu ul li[data-v-1a52a51d]:hover {\n    background: #1E88E5;\n    color: #FAFAFA;\n}\n.right-click-menu ul li ul[data-v-1a52a51d] {\n    display: none;\n    position: absolute;\n    top: 0px;\n    left: var(--submenu-position);\n    width: 250px;\n    background: #FAFAFA;\n    border: 1px solid #BDBDBD;\n    box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 5px 0 rgba(0,0,0,.12);\n}\n.right-click-menu ul li ul li[data-v-1a52a51d] {\n    color: #000;\n}\n.right-click-menu ul li:hover > ul[data-v-1a52a51d] {\n    display: block;\n}\n.right-click-menu ul li:hover ul[data-v-1a52a51d]::before {\n    content: \"\";\n    position:absolute;\n    padding: 100px;\n    z-index: -500;\n    top: -50px;\n    bottom: -50px;\n    left: -30px;\n    right: -30px;\n}\n", map: {"version":3,"sources":["/builds/leapbit-public/lb-vue-floatmenu/src/FloatMenu.vue"],"names":[],"mappings":";AAiGA;IACA,mBAAA;IACA,yBAAA;IACA,iGAAA;IACA,cAAA;IACA,eAAA;IACA,gBAAA;IACA,eAAA;AACA;AAEA;IACA,gBAAA;IACA,SAAA;IACA,UAAA;IACA,YAAA;AACA;AAEA;IACA,gCAAA;IACA,SAAA;IACA,gBAAA;IACA,kBAAA;IACA,eAAA;AACA;AAEA;IACA,iBAAA;IACA,UAAA;IACA,WAAA;IACA,YAAA;AACA;AACA;IACA,WAAA;IACA,UAAA;AACA;AACA;IACA,QAAA;IACA,aAAA;AACA;AACA;IACA,QAAA;IACA,WAAA;AACA;AACA;IACA,kBAAA;IACA,UAAA;IACA,QAAA;AACA;AAEA;IACA,mBAAA;AACA;AAEA;IACA,mBAAA;IACA,cAAA;AACA;AAEA;IACA,aAAA;IACA,kBAAA;IACA,QAAA;IACA,6BAAA;IACA,YAAA;IACA,mBAAA;IACA,yBAAA;IACA,iGAAA;AACA;AAEA;IACA,WAAA;AACA;AAEA;IACA,cAAA;AACA;AAEA;IACA,WAAA;IACA,iBAAA;IACA,cAAA;IACA,aAAA;IACA,UAAA;IACA,aAAA;IACA,WAAA;IACA,YAAA;AACA","file":"FloatMenu.vue","sourcesContent":["<template>\n    <div ref=\"lb_float_menu\" :style=\"'top: '+top+'; bottom: '+bottom+'; left: '+left+'; display: '+display+'; --submenu-position: '+submenuPosition+';'\" class=\"right-click-menu\" v-on:mouseleave=\"evtclose\">\n        <div>\n            <slot :item=\"item\"></slot>\n        </div>\n    </div>\n</template>\n\n<script>\n\nimport ClickOutside from 'vue-click-outside';\n\nexport default\n{\n    name: 'lb-vue-floatmenu',\n    directives: {\n        'click-outside': ClickOutside,\n    },\n    data()\n    {\n        return {\n            top: 'auto',\n            bottom: 'auto',\n            left: 0,\n            display: 'none',\n            item: null,\n            submenuPosition: '249px',\n        };\n    },\n    props: [],\n    mounted()\n    {\n        const me = this;\n\n        window.addEventListener('scroll', me.close);\n    },\n    watch:\n    {\n\n    },\n    methods:\n    {\n        open(e, item)\n        {\n            const me = this;\n            e.preventDefault();\n            e.stopPropagation();\n\n            me.display = '';\n\n            me.item = item;\n\n            if (e.clientY > window.innerHeight / 2)\n            {\n                me.bottom = `${window.innerHeight - e.clientY - 5}px`;\n                me.top = 'auto';\n            }\n            else\n            {\n                me.top = `${e.clientY - 5}px`;\n                me.bottom = 'auto';\n            }\n\n            if (e.clientX + 300 > window.innerWidth)\n            {\n                me.left = `${e.clientX - 5 - 240}px`;\n                me.submenuPosition = '-249px';\n            }\n            else\n            {\n                me.left = `${e.clientX - 5}px`;\n                me.submenuPosition = '249px';\n            }\n        },\n        close()\n        {\n            const me = this;\n\n            me.display = 'none';\n        },\n        evtclose(evt)\n        {\n            const me = this;\n\n            if (evt.relatedTarget == null)\n            {\n                return;\n            }\n\n            me.close();\n        },\n    },\n};\n</script>\n\n<style scoped=\"\">\n\n.right-click-menu {\n    background: #FAFAFA;\n    border: 1px solid #BDBDBD;\n    box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 5px 0 rgba(0,0,0,.12);\n    display: block;\n    position: fixed;\n    min-width: 250px;\n    z-index: 999999;\n}\n\n.right-click-menu ul {\n    list-style: none;\n    margin: 0;\n    padding: 0;\n    z-index: 500;\n}\n\n.right-click-menu ul li {\n    border-bottom: 1px solid #E0E0E0;\n    margin: 0;\n    padding: 5px 5px;\n    position: relative;\n    cursor: pointer;\n}\n\n.right-click-menu div > ul > li::before {\n    position:absolute;\n    content:\"\";\n    left: -15px;\n    right: -15px;\n}\n.right-click-menu div > ul > li:first-child::before {\n    bottom: 0px;\n    top: -30px;\n}\n.right-click-menu div > ul > li:last-child::before{\n    top: 0px;\n    bottom: -30px;\n}\n.right-click-menu div > ul > li:not(:first-child):not(:last-child)::before {\n    top: 0px;\n    bottom: 0px;\n}\n.right-click-menu ul li svg {\n    position: absolute;\n    right: 5px;\n    top: 5px;\n}\n\n.right-click-menu ul li:last-child {\n    border-bottom: none;\n}\n\n.right-click-menu ul li:hover {\n    background: #1E88E5;\n    color: #FAFAFA;\n}\n\n.right-click-menu ul li ul {\n    display: none;\n    position: absolute;\n    top: 0px;\n    left: var(--submenu-position);\n    width: 250px;\n    background: #FAFAFA;\n    border: 1px solid #BDBDBD;\n    box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 5px 0 rgba(0,0,0,.12);\n}\n\n.right-click-menu ul li ul li {\n    color: #000;\n}\n\n.right-click-menu ul li:hover > ul {\n    display: block;\n}\n\n.right-click-menu ul li:hover ul::before {\n    content: \"\";\n    position:absolute;\n    padding: 100px;\n    z-index: -500;\n    top: -50px;\n    bottom: -50px;\n    left: -30px;\n    right: -30px;\n}\n</style>\n\n"]}, media: undefined });

      };
      /* scoped */
      var __vue_scope_id__ = "data-v-1a52a51d";
      /* module identifier */
      var __vue_module_identifier__ = undefined;
      /* functional template */
      var __vue_is_functional_template__ = false;
      /* style inject SSR */
      

      
      var component = normalizeComponent_1(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        browser,
        undefined
      );

    // Import vue component

    exports.default = component;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
